C-# -----------------------------------------------------------------------------------------------------------
C-# ----- DAEMM_10
C-# ----- Einbauteil Daemmung als schraffiertes Polygon mit Aussparungsfunktion und Flaechenangabe
C-# ----- fr die Einbauteilliste, sowie Reports (Abrechungsliste, Aufmablatt)
C-# ----- Stand: 10/2009
C-# -----------------------------------------------------------------------------------------------------------
TEXTVARIABLEN LEITEX,BEZTEX,DNAME
TEXTVARIABLEN HILTEX01,HILTEX02,HILTEX11,HILTEX12,HILTEX13,HILTEX14

ZUWEISEN ISTEU

MAKRO_TYP 2
OBJEKT_TYP 2

C-# --- Pos.Nr. zuweisen und initialisieren
ZUWEISEN_TEXT POS
OBJEKT_POS_INIT POS,VORH

C-# Felder indizieren
C-# max. 10 Polygone (1 Aussen-, 9 Innenpolygone); max. 200 Polygonpunkte insgesamt
C-# ADX=Anfangindex des Polygons; EDX=Endindex des Polygons; X/Y= Polygonpunkte; AP=Polygonflche
VAR_INIT ADX[1:10]=0
VAR_INIT EDX[1:10]=0
VAR_INIT X[1:200]=0
VAR_INIT Y[1:200]=0
VAR_INIT AP[1:10]=0

C-# Voreinstellungen (daemm_10.vor) einlesen
AUFRUF VOREINLESEN

C-# Rcklschen aktivieren
STDFUNKTIONEN 'LINIEN',1,-1,-1,-1

C-# obere Leiste 
LEITEX='Polygone definieren:  Weitere Flaeche'
EINFUEGEN LEITEX
LEISTE LEITEX

C-# ---------------------------------- Polygon(e) definieren
C-# TF = Anzahl der Teilflaechen/Polygone
C-# Wird eine weitere (Teil-)Flaeche gewaehlt, wird der Endindex des vorherigen Polygons EDX[TF-1]=I-1 gesetzt, 
C-# Gleichzeitig wird der Anfangsindex fuer das neue Polygon ADX[TF]=I gesetzt.
C-# PNR = Polygon-Punktnummer, welche fr die Funktionsleiste als Anzeige verwendet wird.

HILTEX01='Flaeche'
HILTEX11='Punkt'
HILTEX12='anfahren'

TF;PNR=1
ADX[TF];EDX[TF]=1

SCHLEIFE I=1,200
	UMWANDELN TEXT 1,TF,HILTEX02
	UMWANDELN TEXT 1,PNR,HILTEX13
	HILTEX14=HILTEX02//'. '//HILTEX01//' | '//HILTEX11//' '//HILTEX13//' '//HILTEX12
	
	SUCHE PUNKT X[I],Y[I],HILTEX14
	
		WENN NFUNKTA=110 UND I=1 STOP
		
	MARKE X[I],Y[I],0		
		
		WENN NFUNKTA>0 DANN
			WENN NFUNKTA=1 DANN
 				TF=TF+1
				EDX[TF-1]=I-1
				ADX[TF]=I
				I=I-1
				PNR=0
			SONST WENN NFUNKTA=111 DANN
				MARKE X[I-1],Y[I-1],-1
				PNR=PNR-2
				I=I-2
			SONST
				EDX[TF]=I-1
				XLOE=I
				GEHE END_POLYGON
			ENDE WENN
		ENDE WENN
	
	PNR=PNR+1
ENDE SCHLEIFE

:END_POLYGON
C-# Rcklschen deaktivieren
STDFUNKTIONEN 'LINIEN',-1,-1,-1,-1

C-# -------------------------------------- Polygonflaeche berechnen
AUFRUF FLAECHENBERECH

C-# -------------------------------------- Schraffur erzeugen
AUFRUF SCHRAFFURERZEUGEN

C-# Markierungen lschen
SCHLEIFE I=1,XLOE
	MARKE X[I],Y[I],-1
ENDE SCHLEIFE

C-# -------------------------------------- Objekt erzeugen
AUFRUF OBJEKTERZEUGEN

STOP

C-# =========================================================================

C-# =========================================================================
UNTERPROGRAMM FLAECHENBERECH
C-# Flaechenberechnung; diese geht als Text in die EBT-, sowie die Abrechnungsliste
C-# TFLAE=Groee der einzelnen Teilflche in cm2, welche den Segmentfaktor beruecksichtigt
C-# LINDX;UINDX=Hilfsvariablen fr die Anfangs- u. Endindizes der Polygone zwischen zu speichern

A=0
LINDX;UINDX=0

SCHLEIFE K=1,TF
        LINDX=ADX[K]
	UINDX=EDX[K]
	
	TFLAE=0

	SCHLEIFE J=LINDX,UINDX-1
		TFLAE=TFLAE+0.5*(X[J]*Y[J+1]-X[J+1]*Y[J])
	ENDE SCHLEIFE

	TFLAE=TFLAE+0.5*(X[J]*Y[LINDX]-X[LINDX]*Y[J])

	F=TFLAE*SEGFAK*SEGFAK
	TFLAE=ABS(F)
	AP[K]=TFLAE
ENDE SCHLEIFE

C-# Anmerkung zu "F=TFLAE*SEGFAK*SEGFAK": Pro Koordinatenrichtung muss die Koordinate
C-# mal dem SEGFAK gesetzt werden, also die Flche wird aus X*Y gerechnet und daher muss
C-# der Flaechenwert nochmals mit (SEGFAK*SEGFAK) multipliziert werden!

C-# Gesamtflaeche = Aussenflaeche AP[1] - alle Innenflaechen AP[K]
C-# Bei TF=1 wird die Schleife automatisch nicht ausgewertet

SCHLEIFE K=2,TF
	AP[1]=AP[1]-AP[K]
ENDE SCHLEIFE

C-# Gesamtflche "A" (cm2)
A=AP[1]

RUECKSPRUNG

C-# =========================================================================
UNTERPROGRAMM OBJEKTERZEUGEN
C-# Objekt Daemmung erzeugen
C-# Positionsdaten anlegen

OBJEKT_POS_VERGL 1

BEZTEX='Daemmung A=%+A;m2%'

OBJEKT_POSITION POS,'daemm_10',BEZTEX,1
OBJEKT_POSITION A

C-# ------------------------------- Objektanfang
OBJEKT_ANFANG EBTNUM

C-# Polygonlinien zeichnen
C-# LINIE XA,YA,XS,YS,LTY1,STIFT1,IDIA,ILIN,EBTNUM,ELTYP
LINDX;UINDX=0

SCHLEIFE K=1,TF
        LINDX=ADX[K]
	UINDX=EDX[K]
	
	SCHLEIFE J=LINDX,UINDX-1
		LINIE X[J],Y[J],X[J+1],Y[J+1],1,5,IDIA,ILIN,EBTNUM,ELTYP
	ENDE SCHLEIFE
	
	LINIE X[LINDX],Y[LINDX],X[UINDX],Y[UINDX],1,5,IDIA,ILIN,EBTNUM,ELTYP
ENDE SCHLEIFE

C-# Zaehlfaktor abfragen
ZAEHLFAKTOR EBTZAEHL,2

C-# Positionsnummer ablegen
OBJEKT_POS_TEXT 0,0,5,0,0,0,0,'%POS%',0,EBTNUM,0,0,X[1],Y[1],0

OBJEKT_ENDE EBTNUM,EBTZAEHL,0,0,0,POS
C-# ------------------------------- Objektende

RUECKSPRUNG

C-# =========================================================================
UNTERPROGRAMM SCHRAFFURERZEUGEN
C-# Polygon schraffieren 
C-# NFL=-1 bedeutet zaehle Polygone selber; max. waren 10 Teilpolygone mglich
C-# Polygone werden ueber Felder schraffiert, 
C-# SCHRAFFUR Anfangsindex, Endindex, X-Array, Y-Array
C-# Wenn Anfang- und End-Index NULL ist wird die Anweisung ueberlesen
C-# Kundenvorgabe: Mauerwerk, Stift-Nr.6=0.13, Abstand=Abfrage, W=45

C-# obere Leiste 
LEITEX='Polygon schraffieren:'
EINFUEGEN LEITEX
LEISTE LEITEX

ZAHL SCHABST,'Schraffurabstand (mm): ENTER='
ABST=(SCHABST*ZEIMAS)/10

AUFRUF VOREINSICHERN

NFL=-1
SCHRAFFUR 3,6,ABST,45,1.1,0.5,NFL,0,ISCH

SCHRAFFUR ADX[1],EDX[1],X,Y
SCHRAFFUR ADX[2],EDX[2],X,Y
SCHRAFFUR ADX[3],EDX[3],X,Y
SCHRAFFUR ADX[4],EDX[4],X,Y
SCHRAFFUR ADX[5],EDX[5],X,Y
SCHRAFFUR ADX[6],EDX[6],X,Y
SCHRAFFUR ADX[7],EDX[7],X,Y
SCHRAFFUR ADX[8],EDX[8],X,Y
SCHRAFFUR ADX[9],EDX[9],X,Y
SCHRAFFUR ADX[10],EDX[10],X,Y

RUECKSPRUNG

C-# =========================================================================
UNTERPROGRAMM VOREINLESEN
C-# Schraffurabstand als Voreinstellung lesen

DNAME=VERZEBT//'daemm_10.vor'

DATEI 21,DNAME
LESEN 21,SCHABST
	WENN FEHLER=-1 SCHABST=2
SCHLIESSE 21

RUECKSPRUNG

C-# =========================================================================
UNTERPROGRAMM VOREINSICHERN
C-# Schraffurabstand als Voreinstellung speichern

DNAME=VERZEBT//'daemm_10.vor'

DATEI 21,DNAME
SCHREIBEN 21,SCHABST
SCHLIESSE 21

RUECKSPRUNG

C-# =========================================================================
