C-# ************************************************************************
C-#                             BEWA-1.PRO
C-# ************************************************************************
C-# 16.05.2014 - Bug 14234 - Heinrich
C-# Laufvariablen aus den gespeicherten Variablen heraus genommen. 

C-# ************************** VARIABLEN ***********************************
C-#   DNAME    = Dateiname                                                
C-#   XNAME    = Standardttextdatei                                       
C-#   BREITE   = Breite des Bewehrungskastens                             
C-#   TYP      = Typ der Bewehrung (Abhaengig von der BREITE)             
C-#   DS       = Durchmesser der Bewehrung                                
C-#   E        = Buegelabstand                                            
C-#   YS       = Hakenlaenge der Typen 1, 11 und 9                        
C-#   EA       = Abstand der Buegel vom Rand                              
C-#   AZ2      = Anzahl der Buegel-1                                      
C-#   BS       = Breite der Bew. in Horizontaler Richtung                 
C-#   HS       = Laenge der Bew. einschl. Profilhoehe ohne lue            
C-#   BSM      = max. Breite der Bew. in Horizontaler Richtung            
C-#   HSM      = max. Laenge der Bew. einschl. Profilhoehe ohne lue       
C-#   BK       = Breite des Profils                                        
C-#   HK       = Hoehe des Profils                                         
C-#   LUE      = lue                                                       
C-#   LISTVAR  = Name der Liste in der Maske                               
C-#   T        = Fuellvariable fuer Maske                                  
C-#   LFUELL   = Fuellvariable fuer Maskenliste                            
C-# ************************************************************************

TEXTVARIABLEN DNAME,XNAME,LESTEXT,LESABM,DUMMY
TEXTVARIABLEN T2,T,T4,__TYPT,__ET,__DST

PRO_VARIABLEN ZAHL,LFUELL,T


DNAME='bewa-1'
XNAME=VERZEBT//'bewa-1.MTX'

ZUWEISEN ISTEU

IDEFAKT_=1

	WENN ISTEU=1 DANN
		TYP=1
		__TYPT='T1'
		ALTTYP=1
		BREITE;ALTBREITE=55
		DS=0.8
		DS10=8
		YS=7.5
		E=15
		__ET='15'
		BK=5.8
		L=125
		LUEMIN;LUEX;LUEMAX=29
		BSMIN;BSX;BSMAX=0
		HSMIN;HSX;HSMAX=17
		D1=' 20'
		D2=' 8'
		LISTVAR='HBT 55- 8/15'
C-#  'Damit das Lightning in Scite funktioniert muss dass leider hier stehen                
		LESABM='HBT 55- 8/15,T1'

		TESTL=0

		MAKRO_AUS_DATEI 'bewa1vor.val'
	ENDE WENN

DS10=DS*10
ALTBREITE=BREITE
ALTTYP=TYP
ALTDS=DS
ALTE=E
EIN_FL_1=0
EIN_FL_2=0
AUFRUF TYPINI_1

	WENN ISTEU>2 GEHE GENERI


C-# ---------------- Eingabe der Daten

:START

C-# ---------------- Listeninhalt loeschen und neu aufbauen (fuellen)

LISTE_LOESCHEN 1


AUFRUF LISTLES

MAKRO_ABM_TYP DNAME,'BREITE',LISTVAR,N,-,TYP,DS,E,BK
LESABM=LISTVAR//','//__TYPT

MAKRO_ABMDATEI DNAME,LESABM,__WEG1,__WEG2,__WEG3,__WEG4,BSMIN,BSMAX,HSMIN,HSMAX,LUEMIN,LUEMAX

ZEILE=N-ABZUG-OFFSET


STEUERLEISTE_ZEIGEN 1,1,1,0



:EINGABE

MASKE_ZEIGEN 1,'bewa-1_1'

MASKE_AKTOBJ ZEILE,'LISTVAR'



:MASK1

MASKE_EINGABE -1,' '

C-# ---------------- Breite aus LISTVAR filtern


T=LISTVAR//','
T4=T[7:7]

	WENN T4='-' DANN
		T2=T[5:6]
	SONST
		T2=T[5:7]
	ENDE WENN

UMWANDELN ZAHL 1,T2,TEST


C-# ---------------- DS und E aus LISTVAR filtern

	WENN TEST<120 DANN
		T2=T[8:9]
		UMWANDELN ZAHL 1,T2,DS10
		DS=DS10/10
		T2=T[11:12]
		UMWANDELN ZAHL 1,T2,E
	
	SONST
		T2=T[9:10]
		UMWANDELN ZAHL 1,T2,DS10
		DS=DS10/10
		T2=T[12:13]
		UMWANDELN ZAHL 1,T2,E
	ENDE WENN


C-# ---------------- Kontrolle auf Aenderungen

	WENN ALTBREITE<>BREITE ODER ALTBREITE<>TEST DANN
			WENN ALTBREITE<>TEST DANN
				BREITE=TEST
			ENDE WENN
		
		AUFRUF LISTLES
		EIN_FL_1=1
	ENDE WENN

	WENN ALTTYP<>TYP DANN
		AUFRUF TYPINI_1
		EIN_FL_1=1
		EIN_FL_2=1
	ENDE WENN

	WENN ALTDS<>DS DANN
		ALTDS=DS
		EIN_FL_1=1
		EIN_FL_2=1
	ENDE WENN

	WENN ALTE<>E DANN
		ALTE=E
		EIN_FL_1=1
	ENDE WENN


C-# ---------------- neues Lesen der Abmessungsdatei

LESABM=LISTVAR//','//__TYPT

MAKRO_ABMDATEI DNAME,LESABM,TYP,DS,E,BK,BSMIN,BSMAX,HSMIN,HSMAX,LUEMIN,LUEMAX



C-# ---------------- Wenn Fehler beim Lesen in der ABM-Datei

	WENN FEHLER=-1 DANN
		GEHE MASK1
	ENDE WENN



C-# ---------------- neue Liste vorbereiten

MAKRO_ABM_TYP DNAME,'BREITE',LISTVAR,N,-,TYP,DS,E,BK

DS10=DS*10
ZEILE=N-ABZUG-OFFSET


C-# ---------------- Maske aktualisieren wenn Eingaben vorhanden

	WENN EIN_FL_1=1 DANN
		BSX=BSMIN
		HSX=HSMIN
		LUEX=LUEMIN
		
		MASKE_AKTOBJ ZEILE,'LISTVAR'
	
		EIN_FL_1=0
	ENDE WENN

	WENN EIN_FL_2=1 DANN
			WENN TYP<>1 UND TYP<>9 DANN
				YS=0
			SONST
				WENN DS=0.8 YS=7.5
				WENN DS=1.0 YS=9.5
				WENN DS=1.2 YS=11.0
			ENDE WENN
	
		EIN_FL_2=0
	ENDE WENN

	
	WENN RETFLAG=0 GEHE MASK1



C-# ---------------- Warnung vor Abweichung von der Standardlaenge

	WENN L<>125 DANN
		MELDUNG_EIN -1,'Elementlnge <> Standardlnge (125 cm)',TESTL
	
			WENN TESTL>1 GEHE EINGABE
	ENDE WENN



C-# ---------------- Makro generieren und Korrekturabfrage

:GENERI

AUFRUF BERECHNE    

MAKRO_IN_DATEI 'bewa1vor.val'

    
MAKRO_GENERIEREN 3,KORR


	WENN KORR=1 GEHE START

STOP

C-# -------------------------------------------------------------------------
C-#            UNTERPROGRAMM      B E R E C H N E
C-# -------------------------------------------------------------------------
UNTERPROGRAMM BERECHNE

AUFRUF TYPINI_2


	WENN BREITE>55 DANN
		HK=3.6
	SONST
		HK=2.8
	ENDE WENN
	

NULL=0
H1=1.2
H0=HK-H1
UEK=0.24
UEK11=0.26
TF=0.25
BF1=BK/3
BF2=BF1+2*UEK
UEF=0.15
PS=0.1
BFPS1=BF1+0.02+PS+1.5*0.12
BFPS2=BFPS1+2*UEK-5.5*0.12
HPS1=H1+PS
HPS0=H0
	

	WENN E=15 DANN
		EA=10
	SONST WENN E=20 DANN
		EA=12.5
	SONST WENN E=25 DANN
		EA=12.5
	ENDE WENN
	

L1=L-2*EA
AZ1=L1/E
AZ2=INT(AZ1)
EA=(L-(AZ2*E))/2

C-# ---------------- Alle Abstaende und Hakenlaengen auf 0 setzen
    VAR_INIT __E[1:33]=0
    VAR_INIT __YS[1:33]=0

C-# ---------------- In Abhaenigkeit der Elementlaenge mit Werten fuellen
    VAR_INIT __E[1:AZ2]=E
    VAR_INIT __YS[1:AZ2+1]=YS

	WENN BREITE>85 ODER BREITE=80 DANN
			WENN BSR<>0 DANN
				UES=(BK-BSR)/2
			SONST
				UES=(BK-BSL)/2
			ENDE WENN
		
		UES2=UES
	
	SONST
		UES=2-DS/2
		UES2=0
	ENDE WENN


TEXT1=N-OFFSET-ZUTEXT


	WENN TYP=10 DANN
		TEXT2=0
	SONST
		TEXT2=65+TYP
	ENDE WENN

	WENN TYP=4 DANN
		AZ4=BS-2*(BK-UES)
		UES2=-(AZ4+(BK-UES))
		BK4=BK
		L4=L
		PS4=PS
		HK4=HK
		H14=H1
		H04=H0
		HPS14=HPS1
		HPS04=HPS0
		TF4=TF
		UEK4=UEK
		UEK114=UEK11
		UEF4=UEF
		BF14=BF1
		BF24=BF2
		BFPS14=BFPS1
		BFPS24=BFPS2
	
	SONST
		AZ4=0
		BK4=0
		L4=0
		PS4=0
		HK4=0
		H14=0
		H04=0
		HPS14=0
		HPS04=0
		TF4=0
		UEK4=0
		UEK114=0
		UEF4=0
		BF14=0
		BF24=0
		BFPS14=0
		BFPS24=0
	ENDE WENN

C-# ---------------- Abstaende und Hakenlaengen abspeichern
VAR_ZUWEISEN E(1:33)=__E[1:33] 
VAR_ZUWEISEN YS(1:33)=__YS[1:33] 

RUECKSPRUNG

C-# -------------------------------------------------------------------------
C-# UNTERPROGRAMM  LISTLES
C-# 
C-# Zweck: liest den Inhalt der Auswahlliste aus der MTX-Datei
C-# -------------------------------------------------------------------------
UNTERPROGRAMM LISTLES

AUFRUF BREITEZU

LSTART=ANZAHL+1

DATEI 20,XNAME

	SCHLEIFE I=1,START-1
		LESEN 20,DUMMY
	ENDE SCHLEIFE

J=1
SCHLUSS=START+ANZAHL-1

	SCHLEIFE I=START,SCHLUSS
		LESEN 20,LESTEXT
		LFUELL[J]=LESTEXT
		J=J+1
	ENDE SCHLEIFE


SCHLIESSE 20

ALTBREITE=BREITE
LESABM=LISTVAR//','//__TYPT

RUECKSPRUNG

C-# -------------------------------------------------------------------------
C-# UNTERPROGRAMM      BREITEZU
C-# 
C-# Zweck: Veraendert verschiedene Werte in abhaengigkeit von der Breite
C-# -------------------------------------------------------------------------
UNTERPROGRAMM BREITEZU

UMWANDELN TEXT 1,E,__ET

DS10=DS*10

	WENN DS10<10 DANN
		UMWANDELN TEXT 1,DS10,T2
		__DST=' '//T2
	SONST
		UMWANDELN TEXT 1,DS10,__DST
	ENDE WENN

	WENN BREITE=55 DANN
		START=1
		ANZAHL=6
		ABZUG=0
		ZUTEXT=0
	
			WENN DS10=10 DANN 
				T4='HBT 55-10/'
			SONST
				T4='HBT 55- 8/'
			ENDE WENN

		LISTVAR=T4//__ET
	
			WENN TYP>4 TYP=1
	
		D2=' 8'

	SONST WENN BREITE=85 DANN
		START=7
		ANZAHL=8
		ABZUG=24
		ZUTEXT=18
	
			WENN DS10>8 DANN 
				T4='HBT 85-'//__DST//'/'
			SONST
				T4='HBT 85-10/'
			ENDE WENN

		LISTVAR=T4//__ET
	
			WENN TYP>4 TYP=1
	
		D2=' 9'

	SONST WENN BREITE=120 DANN
		START=15
		ANZAHL=9
		ABZUG=56
		ZUTEXT=42
	
			WENN DS10>6 DANN 
				T4='HBT 120-'//__DST//'/'
			SONST
				T4='HBT 120- 8/'
			ENDE WENN

		LISTVAR=T4//__ET
	
			WENN TYP<5 ODER TYP=10 TYP=5
	
		D2='13-18'

	SONST WENN BREITE=150 DANN
		START=24
		ANZAHL=11
		ABZUG=101
		ZUTEXT=78
	
			WENN DS10>6 DANN 
				T4='HBT 150-'//__DST//'/'
			SONST
				T4='HBT 150- 8/'
			ENDE WENN
	
		LISTVAR=T4//__ET
	
			WENN TYP<5 ODER TYP=10 TYP=5
	
		D2='16-21'

	SONST WENN BREITE=190 DANN
		START=35
		ANZAHL=11
		ABZUG=156
		ZUTEXT=122
	
			WENN DS10>6 DANN 
				T4='HBT 190-'//__DST//'/'
			SONST
				T4='HBT 190- 8/'
			ENDE WENN

		LISTVAR=T4//__ET
	
			WENN TYP<5 ODER TYP=10 TYP=5
	
		D2='19-24'

	SONST WENN BREITE=220 DANN
		START=46
		ANZAHL=11
		ABZUG=211
		ZUTEXT=166
	
			WENN DS10>6 DANN 
				T4='HBT 220-'//__DST//'/'
			SONST
				T4='HBT 220- 8/'
			ENDE WENN
	
		LISTVAR=T4//__ET
	
			WENN TYP<5 ODER TYP=10 TYP=5
	
		D2='23-28'

	SONST WENN BREITE=80 DANN
		START=57
		ANZAHL=9
		ABZUG=266
		ZUTEXT=210
	
			WENN DS10=6 T4='HBT 80- 6/'
			WENN DS10=8 T4='HBT 80- 8/'
			WENN DS10=10 T4='HBT 80-10/'

		LISTVAR=T4//__ET
		TYP=10
		D2=' 12'
	ENDE WENN



AUFRUF TYPINI_1


RUECKSPRUNG


C-# -------------------------------------------------------------------------
C-# UNTERPROGRAMM      TYPINI_1
C-# -------------------------------------------------------------------------
UNTERPROGRAMM TYPINI_1


UMWANDELN TEXT 1,TYP,T2
__TYPT='T'//T2


	WENN BREITE=55 DANN
		ANZEI=6	
	SONST WENN BREITE=85 DANN
		ANZEI=8	
	SONST WENN BREITE=120 DANN
		ANZEI=9	
	SONST 
		ANZEI=11	
	ENDE WENN

	WENN TYP=10 DANN
		OFFSET=0
	SONST WENN TYP>4 DANN
		OFFSET=(TYP-5)*ANZEI
	SONST
		OFFSET=(TYP-1)*ANZEI
	ENDE WENN

ALTTYP=TYP


RUECKSPRUNG

C-# -------------------------------------------------------------------------
C-# UNTERPROGRAMM      TYPINI_2
C-# -------------------------------------------------------------------------
UNTERPROGRAMM TYPINI_2
	
BS=BSX
HS=HSX
LUE=LUEX
	
DBR=4*DS
	
	WENN BREITE=120 UND DS>0.8 DBR=(BS-2*DS)/2

BSL=0
BSR=0
HSU=0
LUEU=0


C-# ------------ Variablen fuer Detaildarstellung initzialisieren -------------

DBRLO=0
DBRDSLO=0
DBRLU=0
DBRDSLU=0
DBRRO=0
DBRDSRO=0
DBRRU=0
DBRDSRU=0

DSLO=0
DSLU=0
DSR=0
DSU=0

BSL11=0
BSL118=0
BSR11=0
HS11=0
LUE11=0
HSU11=0
LUEU11=0

ESLO=0
ESL=0
ESLU=0
ESRO=0
ESRU=0

AZ8=0


	WENN TYP=1 DANN
		HS11=HS
		LUE11=LUE
		ESLO=DS
		ESRO=DS

	SONST WENN TYP=2 DANN
		BSL=BS
		DBRLO=DBR
		DBRDSLO=DBR+DS
		DSLO=DS
		BSL11=BSX-DBRDSLO
		HS11=HSX-DBRDSLO
		LUE11=LUE
		ESL=DS
		ESRO=DS

	SONST WENN TYP=3 DANN
		HS11=HS
		LUE11=LUE
		ESLO=DS
		ESRO=DS

	SONST WENN TYP=4 DANN
		BSL=BS
		HSU=HS
		LUEU=LUE

		DBRLO=DBR
		DBRDSLO=DBR+DS
		DBRLU=DBR
		DBRDSLU=DBR+DS
		DSU=DS
		BSL11=BS-2*DBRDSLO
		HS11=HS-DBRDSLO
		LUE11=LUE
		HSU11=HS-DBRDSLU
		LUEU11=LUE
		ESRO=DS
		ESRU=DS

	SONST WENN TYP=5 DANN
		BSL=BS
		HSU=HS
		LUEU=LUE
	
		DBRLO=DBR
		DBRDSLO=DBR+DS
		DBRLU=DBR
		DBRDSLU=DBR+DS
		DSU=DS
		BSL11=BS-2*DBRDSLO
		HS11=HS-DBRDSLO
		LUE11=LUE
		HSU11=HS-DBRDSLU
		LUEU11=LUE
		ESRO=DS
		ESRU=DS

	SONST WENN TYP=6 DANN
		BSR=BS
		HSU=HS
		LUEU=LUE
	
		DBRRO=DBR
		DBRDSRO=DBR+DS
		DBRRU=DBR
		DBRDSRU=DBR+DS
		DSU=DS
		DSR=DS
		BSR11=BS-2*DBRDSRO
		HS11=HS
		LUE11=LUE-DBRDSRO
		HSU11=HS
		LUEU11=LUE-DBRDSRU
		ESLO=DS
		ESLU=DS

	SONST WENN TYP=7 DANN
			WENN DS=0.8 BSL=BS+7.5
			WENN DS=1.0 BSL=BS+9.5
			WENN DS=1.2 BSL=BS+11.0
	
		BSR=BS
		HSU=HS
		LUEU=LUE
	
		DBRLO=DBR
		DBRDSLO=DBR+DS
		DBRRO=DBR
		DBRDSRO=DBR+DS
		DBRRU=DBR
		DBRDSRU=DBR+DS
		DSU=DS
		DSR=DS
		DSLO=DS
		BSL11=BSL-DBRDSLO
		BSR11=BS-2*DBRDSRO
		HS11=HS-DBRDSLO
		LUE11=LUE-DBRDSRO
		HSU11=HS-DS-0.5
		LUEU11=LUE-DBRDSRU
		ESL=DS
		ESLU=DS

	SONST WENN TYP=8 DANN
		AZ8=DBRRU
		BSL=BS
		BSR=BS
		HSU=HS
		LUEU=LUE
	
		DBRLO=DBR
		DBRDSLO=DBR+DS
		DBRLU=DBR
		DBRDSLU=DBR+DS
		DBRRO=DBR
		DBRDSRO=DBR+DS
		DBRRU=DBR
		DBRDSRU=DBR+DS
		DSU=DS
		DSR=DS
		DSLO=DS
		DSLU=DS
		AZ8=DBRLU
		
			WENN DS=0.8 BS2=7.5
			WENN DS=1.0 BS2=9.5
			WENN DS=1.2 BS2=11.0
	
		BSL11=BS2-DBRDSLO
		BSL118=BS2-DBRDSLO
		BSR11=BS-2*DBRDSRO
		HS11=HS-DBRDSLO
		LUE11=LUE-DBRDSRO
		HSU11=HS-DBRDSLU-DS-0.5
		LUEU11=LUE-DBRDSRU
		ESL=DS

	SONST WENN TYP=9 DANN
		BSR=BS
		HSU=HS
		LUEU=LUE
	
		DBRRO=DBR
		DBRDSRO=DBR+DS
		DBRRU=DBR
		DBRDSRU=DBR+DS
		DSU=DS
		DSR=DS
		BSR11=BS-2*DBRDSRO
		HS11=HS
		LUE11=LUE-DBRDSRO
		HSU11=HS
		LUEU11=LUE-DBRDSRU
		ESLO=DS
		ESLU=DS

	SONST WENN TYP=10 DANN
		BSR=BS
		HSU=HS
		LUEU=LUE
	
		DBR=(BS-2*DS)/2
		DBRRO=DBR
		DBRDSRO=DBR+DS
		DBRRU=DBR
		DBRDSRU=DBR+DS
		DSU=DS
		BSR11=BS-2*DBRDSRO
		HS11=HS
		LUE11=LUE-DBRDSRO
		HSU11=HS
		LUEU11=LUE-DBRDSRU
		ESLO=DS
		ESLU=DS
	ENDE WENN
RUECKSPRUNG
